import Control.Parallel.Eden
import System.Environment

main = do args <- getArgs
          let first_stuff = (process f_expensive) # (args!!0)
              other_stuff = g_expensive $# (args!!1) -- syntax variant
          putStrLn (show first_stuff ++ '\n':show other_stuff)

f_expensive, g_expensive :: String -> [Integer]
f_expensive arg = take 10 (drop (read arg) primes)
g_expensive arg = map slow_fib [ 10 .. read arg ]


--------------------------------------------------------
-- some functions
primes :: [Integer]
primes = sieve [2,3..]

sieve (p:xs) 
    = p : sieve [ x | x <- xs, x `mod` p > 0 ]
    -- = p : sieve ( filter ( (>0) . (`mod` p)) xs)


fibonacci :: [Integer]
-- fibonacci = [0,1] ++ zipWith (+) fibonacci (tail fibonacci)
fibonacci = [0,1] ++ [ a+b | (a,b) <- zip fibonacci (tail fibonacci) ]

fast_fib :: Int -> Integer
fast_fib n = fibonacci!!n

slow_fib :: Int -> Integer
slow_fib n | n == 0    = 0
           | n == 1    = 1
           | otherwise = let f1 = slow_fib (n-1) 
                             f2 = slow_fib (n-2)
                         in f1 + f2

-- fib using an accumulator
better_fib :: Int -> Integer
better_fib 0 = 0
better_fib 1 = 1
better_fib n = fib_accum (0,1) (n-1)
    where fib_accum (a1,a2) 1 = a1 + a2
          fib_accum (a1,a2) n = fib_accum (a2, a2+a1) (n-1)

